package gls.ch03.s01;
import junit.framework.*;
import org.codehaus.groovy.tck.*;
public class Unicode1Test extends TestCase {
    public void testPass() throws Throwable {
        StringBuffer srcBuffer = new StringBuffer();
        srcBuffer.append("package gls.ch03.s01;").append(lineSep);
        srcBuffer.append("/**").append(lineSep);
        srcBuffer.append(" * Except for comments, identifiers and the contents of ... string ").append(lineSep);
        srcBuffer.append(" * literals, all input elements are formed from ASCII characters.").append(lineSep);
        srcBuffer.append(" *").append(lineSep);
        srcBuffer.append(" * TODO: Find a better way to test these things").append(lineSep);
        srcBuffer.append(" * Note that this is a little hard to test since the input file is ASCII.").append(lineSep);
        srcBuffer.append(" *").append(lineSep);
        srcBuffer.append(" * @author Alan Green").append(lineSep);
        srcBuffer.append(" * @author Jeremy Rayner").append(lineSep);
        srcBuffer.append(" */").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("class Unicode1 extends GroovyTestCase {").append(lineSep);
        srcBuffer.append("    //TODO: find some way to assert that Unicode3.0 + is available").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("    /**").append(lineSep);
        srcBuffer.append("      * This doc comment checks that Unicode is allowed in javadoc.").append(lineSep);
        srcBuffer.append("      * e.g. \\u05D0\\u2136\\u05d3\\u05d7").append(lineSep);
        srcBuffer.append("      */").append(lineSep);
        srcBuffer.append("    public void testComments() {").append(lineSep);
        srcBuffer.append("        // Unicode is allowed in comments").append(lineSep);
        srcBuffer.append("        // This is a comment \\u0410\\u0406\\u0414\\u0419").append(lineSep);
        srcBuffer.append("        /* Another comment \\u05D0\\u2136\\u05d3\\u05d7 */").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("        /**/ // Tiny comment").append(lineSep);
        srcBuffer.append("        /***/ // Also valid").append(lineSep);
        srcBuffer.append("    }").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("    public void testStringLiterals() {").append(lineSep);
        srcBuffer.append("        assert 1 == \"\\u0040\".length()").append(lineSep);
        srcBuffer.append("        assert \"A\" == \"\\u0041\"").append(lineSep);
        srcBuffer.append("    }").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("    public void testCharNotAvailableAsLiteral() {").append(lineSep);
        srcBuffer.append("        char a = 'x'").append(lineSep);
        srcBuffer.append("        char b = \"x\"").append(lineSep);
        srcBuffer.append("        def c = \"x\".charAt(0)").append(lineSep);
        srcBuffer.append("        assert a == b").append(lineSep);
        srcBuffer.append("        assert a == c ").append(lineSep);
        srcBuffer.append("    }").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("}").append(lineSep);
        srcBuffer.append("").append(lineSep);
        Object result = helper.evaluate(srcBuffer.toString(),"testPass");
        if (result instanceof TestResult) {
            TestResult testResult = (TestResult)result;
            if (testResult.errorCount() > 0) {
                TestFailure firstTestFailure = (TestFailure)testResult.errors().nextElement();
                throw firstTestFailure.thrownException();
            }
            if (testResult.failureCount() > 0) {
                AssertionFailedError firstFailure = (AssertionFailedError)(testResult.failures().nextElement());
                throw firstFailure;
            }
        }
    }
    protected String lineSep = System.getProperty("line.separator");
    protected TestGeneratorHelper helper = new ClassicGroovyTestGeneratorHelper();
}
