package gls.ch03.s02;
import junit.framework.*;
import org.codehaus.groovy.tck.*;
public class LexicalTranslation1Test extends TestCase {
    public void testPass() throws Throwable {
        StringBuffer srcBuffer = new StringBuffer();
        srcBuffer.append("package gls.ch03.s02").append(lineSep);
        srcBuffer.append("").append(lineSep);
        srcBuffer.append("/** Checks Lexical Translation steps as defined in $3.2 of GLS").append(lineSep);
        srcBuffer.append(" * @author Jeremy Rayner").append(lineSep);
        srcBuffer.append(" */").append(lineSep);
        srcBuffer.append("class LexicalTranslation1 extends GroovyTestCase {").append(lineSep);
        srcBuffer.append("    void testTranslationOfUnicodeEscapes() {").append(lineSep);
        srcBuffer.append("        assert \"A\" == \"\\u0041\"").append(lineSep);
        srcBuffer.append("    }").append(lineSep);
        srcBuffer.append("    //todo: test that we have a stream of tokens (RI is antlr specific...)").append(lineSep);
        srcBuffer.append("}").append(lineSep);
        srcBuffer.append("").append(lineSep);
        Object result = helper.evaluate(srcBuffer.toString(),"testPass");
        if (result instanceof TestResult) {
            TestResult testResult = (TestResult)result;
            if (testResult.errorCount() > 0) {
                TestFailure firstTestFailure = (TestFailure)testResult.errors().nextElement();
                throw firstTestFailure.thrownException();
            }
            if (testResult.failureCount() > 0) {
                AssertionFailedError firstFailure = (AssertionFailedError)(testResult.failures().nextElement());
                throw firstFailure;
            }
        }
    }
    protected String lineSep = System.getProperty("line.separator");
    protected TestGeneratorHelper helper = new ClassicGroovyTestGeneratorHelper();
}
